From 0a03575ec857eef48ffdf9a70d372cd385e78949 Mon Sep 17 00:00:00 2001
From: Hiroshi Miura <miurahr@linux.com>
Date: Fri, 15 Jun 2012 07:06:10 +0900
Subject: [PATCH 2/2] VESA EDID: switch as low-resolution

---
 Makefile |   16 ++++++++--------
 vbe.c    |   14 +++++++-------
 2 files changed, 15 insertions(+), 15 deletions(-)

diff --git a/Makefile b/Makefile
index c303709..bfaf34f 100644
--- a/Makefile
+++ b/Makefile
@@ -14,13 +14,13 @@ RELVERS = `pwd | sed "s-.*/--" | sed "s/vgabios//" | sed "s/-//"`
 
 VGABIOS_DATE = "-DVGABIOS_DATE=\"$(RELDATE)\""
 
-all: bios cirrus-bios hires-bios
+all: bios cirrus-bios lowres-bios
 
 bios: vgabios.bin vgabios.debug.bin
 
 cirrus-bios: vgabios-cirrus.bin vgabios-cirrus.debug.bin
 
-hires-bios: vgabios-hires.bin vgabios-hires.debug.bin
+lowres-bios: vgabios-lowres.bin vgabios-lowres.debug.bin
 
 clean:
 	/bin/rm -f  biossums vbetables-gen vbetables.h *.o *.s *.ld86 \
@@ -37,24 +37,24 @@ vgabios.bin              : VGAFLAGS := -DVBE -DPCIBIOS
 vgabios.debug.bin        : VGAFLAGS := -DVBE -DPCIBIOS -DDEBUG
 vgabios-cirrus.bin       : VGAFLAGS := -DCIRRUS -DPCIBIOS
 vgabios-cirrus.debug.bin : VGAFLAGS := -DCIRRUS -DPCIBIOS -DCIRRUS_DEBUG
-vgabios-hires.bin        : VGAFLAGS := -DVBE -DPCIBIOS -DHIRES
-vgabios-hires.debug.bin  : VGAFLAGS := -DVBE -DPCIBIOS -DHIRES -DDEBUG
+vgabios-lowres.bin        : VGAFLAGS := -DVBE -DPCIBIOS -DLOWRES
+vgabios-lowres.debug.bin  : VGAFLAGS := -DVBE -DPCIBIOS -DLOWRES -DDEBUG
 
 # dist names
 vgabios.bin              : DISTNAME := VGABIOS-lgpl-latest.bin
 vgabios.debug.bin        : DISTNAME := VGABIOS-lgpl-latest.debug.bin
 vgabios-cirrus.bin       : DISTNAME := VGABIOS-lgpl-latest.cirrus.bin
 vgabios-cirrus.debug.bin : DISTNAME := VGABIOS-lgpl-latest.cirrus.debug.bin
-vgabios-hires.bin        : DISTNAME := VGABIOS-lgpl-latest.hires.bin
-vgabios-hires.debug.bin  : DISTNAME := VGABIOS-lgpl-latest.hires.debug.bin
+vgabios-lowres.bin        : DISTNAME := VGABIOS-lgpl-latest.lowres.bin
+vgabios-lowres.debug.bin  : DISTNAME := VGABIOS-lgpl-latest.lowres.debug.bin
 
 # dependencies
 vgabios.bin              : $(VGA_FILES) $(VBE_FILES) biossums
 vgabios.debug.bin        : $(VGA_FILES) $(VBE_FILES) biossums
 vgabios-cirrus.bin       : $(VGA_FILES) clext.c biossums
 vgabios-cirrus.debug.bin : $(VGA_FILES) clext.c biossums
-vgabios-hires.bin        : $(VGA_FILES) $(VBE_FILES) biossums
-vgabios-hires.debug.bin  : $(VGA_FILES) $(VBE_FILES) biossums
+vgabios-lowres.bin        : $(VGA_FILES) $(VBE_FILES) biossums
+vgabios-lowres.debug.bin  : $(VGA_FILES) $(VBE_FILES) biossums
 
 # build rule
 %.bin:
diff --git a/vbe.c b/vbe.c
index 80e3690..563794a 100644
--- a/vbe.c
+++ b/vbe.c
@@ -1497,18 +1497,18 @@ vesa_EDID:
   db 0x31, 0x59                       /* 0x0026 Standard timing #1 (640 x 480 @ 85 Hz) */
   db 0x45, 0x59                       /* 0x0028 Standard timing #2 (800 x 600 @ 85 Hz) */
   db 0x61, 0x59                       /* 0x002A Standard timing #3 (1024 x 768 @ 85 Hz) */
-#ifdef HIRES
-  db 0x81, 0xCA                       /* 0x002C Standard timing #4 (1280 x 720 @ 70 Hz) */
-  db 0x81, 0x4A                       /* 0x002E Standard timing #5 (1280 x 960 @ 60 Hz) */
-  db 0x95, 0x00                       /* 0x0030 Standard timing #6 (1440 x 900 @ 60 Hz) */
-  db 0xA9, 0x40                       /* 0x0034 Standard timing #7 (1600 x 1200 @ 60 Hz) */
-  db 0xB3, 0x00                       /* 0x0032 Standard timing #8 (1680 x 1050 @ 60 Hz) */
-#else
+#ifdef LOWRES
   db 0x31, 0x4A                       /* 0x002C Standard timing #4 (640 x 480 @ 70 Hz) */
   db 0x01, 0x01                       /* 0x002E Standard timing #5 (unused) */
   db 0x01, 0x01                       /* 0x0030 Standard timing #6 (unused) */
   db 0x01, 0x01                       /* 0x0032 Standard timing #7 (unused) */
   db 0x01, 0x01                       /* 0x0034 Standard timing #8 (unused) */
+#else
+  db 0x81, 0xCA                       /* 0x002C Standard timing #4 (1280 x 720 @ 70 Hz) */
+  db 0x81, 0x4A                       /* 0x002E Standard timing #5 (1280 x 960 @ 60 Hz) */
+  db 0x95, 0x00                       /* 0x0030 Standard timing #6 (1440 x 900 @ 60 Hz) */
+  db 0xA9, 0x40                       /* 0x0034 Standard timing #7 (1600 x 1200 @ 60 Hz) */
+  db 0xB3, 0x00                       /* 0x0032 Standard timing #8 (1680 x 1050 @ 60 Hz) */
 #endif
 
                                       /* 0x0036 First 18-byte descriptor (1152 x 864) */
-- 
1.7.5.4